<template>
	<a-drawer
		:title="'审批放款单'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="审批：" name="bankOpApprovalState">
				<a-radio-group v-model:value="formData.bankOpApprovalState" placeholder="请选择"
							   :options="[{label:'已审批',value:'已审批'},{label:'未通过',value:'未通过'}]"/>
			</a-form-item>
			<a-form-item label="审批信息：" name="approvalMsg">
				<a-textarea v-model:value="formData.approvalMsg" placeholder="请输入审批信息" :auto-size="{ minRows: 3, maxRows: 10 }"/>
			</a-form-item>
			<p>※ 未通过流程 ：未通过时，状态变为已确认，文件可以重新上传</p>
			<p>※ 放款流程 ：申请放款单 → 银行审批</p>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">确认</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotLoanGrantForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required, rules} from '@/utils/formRules'
import depotLoanGrantApi from '@/api/biz/depotLoanGrantApi'
import depotGrainInfoApi from '@/api/biz/depotGrainInfoApi'
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)

// 打开抽屉
const onOpen = (record) => {
	if (record) {
		visible.value = true
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
		formData.value.bankOpApprovalState = '已审批'
	}
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotLoanGrantApi
				.bankOpApproval({id: formDataParam.id, bankOpApprovalState: formDataParam.bankOpApprovalState, approvalMsg: formDataParam.approvalMsg})
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
